package it.bb.wof.model;

import static javax.persistence.GenerationType.IDENTITY;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.Length;

@Entity
@Table(name = "denominazioni", catalog = "wof")
public class Denominazione {

	private Long idDenominazione;
	private String codiceDenominazione;
	private Regione regione;
	@Version
	@Column(name = "version")
	private int version = 0;

	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column
	public Long getIdDenominazione() {
		return idDenominazione;
	}

	public void setIdDenominazione(Long idDenominazione) {
		this.idDenominazione = idDenominazione;
	}

	@Column(name = "codiceDenominazione", nullable = false, length = 50)
	@NotNull
	@Length(max = 50)
	public String getCodiceDenominazione() {
		return codiceDenominazione;
	}

	public void setCodiceDenominazione(String descrizione) {
		this.codiceDenominazione = descrizione;
	}

	@ManyToOne
	@JoinColumn(name = "idRegione")
	public Regione getRegione() {
		return regione;
	}

	public void setRegione(Regione regione) {
		this.regione = regione;
	}

	   public int getVersion()
	   {
	      return this.version;
	   }

	   public void setVersion(final int version)
	   {
	      this.version = version;
	   }

	   
	   @Override
	   public String toString()
	   {
	      String result = getClass().getSimpleName() + " ";
	      if (idDenominazione != null)
	         result += "id: " + idDenominazione;
	      return result;
	   }

	   @Override
	   public boolean equals(Object obj)
	   {
	      if (this == obj)
	      {
	         return true;
	      }
	      if (!(obj instanceof Denominazione))
	      {
	         return false;
	      }
	      Denominazione other = (Denominazione) obj;
	      if (idDenominazione != null)
	      {
	         if (!idDenominazione.equals(other.idDenominazione))
	         {
	            return false;
	         }
	      }
	      return true;
	   }

	   @Override
	   public int hashCode()
	   {
	      final int prime = 31;
	      int result = 1;
	      result = prime * result + ((idDenominazione == null) ? 0 : idDenominazione.hashCode());
	      return result;
	   }

	
}
