package it.bb.wof.model;

import static javax.persistence.GenerationType.IDENTITY;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.Length;

import java.lang.Override;

@Entity
@Table(name = "regioni", catalog = "wof")
public class Regione
{

   private String codiceRegione;
   private Long idRegione;
   @Version
   @Column(name = "version")
   private int version = 0;
   

   @Column(name = "codiceRegione", nullable = false, length = 50)
   @NotNull
   @Length(max = 50)
   public String getCodiceRegione()
   {
      return codiceRegione;
   }

   public void setCodiceRegione(String descrizione)
   {
      this.codiceRegione = descrizione;
   }

   @Id
   @GeneratedValue(strategy = IDENTITY)
   @Column
   public Long getIdRegione()
   {
      return this.idRegione;
   }

   public void setIdRegione(final Long idRegione)
   {
      this.idRegione = idRegione;
   }

   
   public int getVersion()
   {
      return this.version;
   }

   public void setVersion(final int version)
   {
      this.version = version;
   }

   
   @Override
   public String toString()
   {
      String result = getClass().getSimpleName() + " ";
      if (idRegione != null)
         result += "id: " + idRegione;
      return result;
   }

   @Override
   public boolean equals(Object obj)
   {
      if (this == obj)
      {
         return true;
      }
      if (!(obj instanceof Regione))
      {
         return false;
      }
      Regione other = (Regione) obj;
      if (idRegione != null)
      {
         if (!idRegione.equals(other.idRegione))
         {
            return false;
         }
      }
      return true;
   }

   @Override
   public int hashCode()
   {
      final int prime = 31;
      int result = 1;
      result = prime * result + ((idRegione == null) ? 0 : idRegione.hashCode());
      return result;
   }
   

}
